package examples;

import javax.naming.*;
import javax.security.auth.*;
import javax.security.auth.callback.*;
import javax.security.auth.login.*;
import javax.rmi.PortableRemoteObject;


public class HelloCallbackHandler implements CallbackHandler {
    private String username;
    private String password;


    public HelloCallbackHandler() {
        LoginDialog dialog = new LoginDialog("User Authentication Required");
        String[] data = dialog.getData();
        this.username = data[0];
        this.password = data[1];
    }

    public void handle(Callback[] callbacks) throws
            java.io.IOException, UnsupportedCallbackException {
        for (int i = 0; i < callbacks.length; i++) {
            if (callbacks[i] instanceof NameCallback) {
                NameCallback nc = (NameCallback) callbacks[i];
                nc.setName(username);
            } else if (callbacks[i] instanceof PasswordCallback) {
                PasswordCallback pc = (PasswordCallback) callbacks[i];
                pc.setPassword( preparePassword(password) );
            } else {
                throw new UnsupportedCallbackException(callbacks[i], "Unrecognized Callback");
            }
        }
    }
    
    /**
     * This method may be used to treat the password before sending
     */
    private char[] preparePassword(String word) {
        return word.toCharArray();
    }
}


