package examples;

import javax.naming.*;
import javax.security.auth.*;
import javax.security.auth.callback.*;
import javax.security.auth.login.*;
import javax.rmi.PortableRemoteObject;

public class HelloClient {

    public static void main(String[] args) throws Exception {

        /*
         *  Authenticate via JAAS
         */
        CallbackHandler handler = new HelloCallbackHandler();
        // "other"  nome da configurao default no JBoss ( definida na spec JAAS
        // como o nome da configurao que ser buscada caso o nome passado como parmetro
        // no seja encontrado - ou seja, equivale a passar qualquer coisa como primeiro parametro)
        LoginContext loginContext = new LoginContext("other", handler);
        loginContext.login();

        /*
         *  Retrieve the logged-in subject
         */
        Subject subject = loginContext.getSubject();

        /*
         *  Perform business logic while impersonating the
         *  authenticated subject
         */
        CallHelloWorld action = new CallHelloWorld();
        String result = (String) Subject.doAs(subject, action);

        /*
         *  Print the return result from the business logic
         */
        System.out.println(result);
    }
}

